//+------------------------------------------------------------------+
//|                                                      OmniFX.mq4  |
//|                                    http://www.prekybaforex.lt    |
//+------------------------------------------------------------------+
#property copyright "Copyright 2009 Nakagava Ltd."
#property link      "http://www.prekybaforex.lt"

extern int     MagicNumber= 123;
extern double  Lots= 1;
extern bool    UseHedge= true;
extern double  TPMultiplier= 1;
extern double  SLMultiplier= 1;
extern int     EMA_PERIOD= 24;
extern int     FAST_EMA_PERIOD= 12;
extern int     SLOW_EMA_PERIOD= 26;
extern int     MACD_SIGNAL_PERIOD= 9;
extern int     ATR_PERIOD= 14;

datetime lastTrade;
int state;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   lastTrade= 0;
   state= 0;
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
  
void CloseOrders(int type)
{
   for(int cnt= OrdersTotal()-1; cnt>=0; cnt--)
   if(OrderSelect(cnt, SELECT_BY_POS))
   if(OrderMagicNumber()==MagicNumber)
   if(OrderType()==type && (OrderProfit()+OrderSwap())>0)
      OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), MarketInfo(Symbol(), MODE_SPREAD), White);
}  
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   double macd[2];   
   double signal[2];
   int i;
   
   for(i=0;i<2;i++)
   {
   macd[i]= iMACD(Symbol(), 0, FAST_EMA_PERIOD, SLOW_EMA_PERIOD, MACD_SIGNAL_PERIOD, PRICE_TYPICAL, MODE_MAIN, i+1);
   signal[i]= iMACD(Symbol(), 0, FAST_EMA_PERIOD, SLOW_EMA_PERIOD, MACD_SIGNAL_PERIOD, PRICE_TYPICAL, MODE_SIGNAL, i+1);
   }
   
   if(UseHedge)
   {
      if(macd[0]>signal[0] && macd[1]<=signal[1] && macd[0]<0 && signal[0]<0)
      {
         CloseOrders(OP_SELL);

         if(state!=1)
         if(-1!=OrderSend(Symbol(), OP_BUY, Lots, Ask, MarketInfo(Symbol(), MODE_SPREAD), 0,
            0, WindowExpertName(), MagicNumber, 0, Green))                           
               state= 1;
            
      }
   
      if(macd[0]<signal[0] && macd[1]>=signal[1] && macd[0]>0 && signal[0]>0)
      {
         CloseOrders(OP_BUY);

         if(state!=2)
         if(-1!=OrderSend(Symbol(), OP_SELL, Lots, Bid, MarketInfo(Symbol(), MODE_SPREAD), 0,
            0, WindowExpertName(), MagicNumber, 0, Red))
            state= 2;                        
      }   
   }   
   else 
   {
      double signalAr[100];
      double atr= iATR(Symbol(), 0, ATR_PERIOD, 0);
      
      ArraySetAsSeries(signalAr,true);

      for(int cnt=0; cnt<100; cnt++)
         signalAr[cnt]= iMACD(Symbol(), 0, FAST_EMA_PERIOD, SLOW_EMA_PERIOD, MACD_SIGNAL_PERIOD, PRICE_TYPICAL, MODE_SIGNAL, cnt);
      double signalMA[2];
      
      signalMA[0]= iMAOnArray(signalAr,0,EMA_PERIOD,0,MODE_EMA,1);
      signalMA[1]= iMAOnArray(signalAr,0,EMA_PERIOD,0,MODE_EMA,2);
      
      if(signal[0]<0 && macd[0]>signalMA[0] && macd[1]<=signalMA[1])
      {
         if(state!=1)
         if(-1!=OrderSend(Symbol(), OP_BUY, Lots, Ask, MarketInfo(Symbol(), MODE_SPREAD), 
            Ask-NormalizeDouble(atr*SLMultiplier, Digits),
            Ask+NormalizeDouble(atr*TPMultiplier, Digits), WindowExpertName(), MagicNumber, 0, Green))
            state= 1;         
      }
      
      if(signal[0]>0 && macd[0]<signalMA[0] && macd[1]>=signalMA[1])
      {
         if(state!=2)
         if(-1!=OrderSend(Symbol(), OP_SELL, Lots, Bid, MarketInfo(Symbol(), MODE_SPREAD), 
            Bid+NormalizeDouble(atr*SLMultiplier, Digits),
            Bid-NormalizeDouble(atr*TPMultiplier, Digits), WindowExpertName(), MagicNumber, 0, Red))
            state= 2;      
      }
      
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+